
CREATE TABLE sk_invoices (
    id SERIAL8 PRIMARY KEY,
    amount NUMERIC(16,2) NOT NULL default '0.00' CHECK (amount > 0),
    account INT8 not null default '1',
    "desc" TEXT,
    phone TEXT,
    resp_person INT8 NOT NULL DEFAULT '0' CHECK (resp_person >= 0),
    creation_time timestamp without time zone NOT NULL default CURRENT_TIMESTAMP,
    pay_time timestamp without time zone NOT NULL default '1970-01-01 00:00',
    comment TEXT,
    hash VARCHAR(64) not null default ''
);

CREATE TABLE sk_payments (
        payment_id serial8 PRIMARY KEY,
	account_id int8  default '0' NOT NULL CHECK (account_id > 0),
	operator_id int8  default '0' NOT NULL CHECK (operator_id >= 0),
	doc_id int8  default '0' NOT NULL CHECK (doc_id >= 0),
	status int not null default '0' CHECK (status >= 0 AND status < 3),
	"date" timestamp without time zone NOT NULL default CURRENT_TIMESTAMP,
	sum numeric(16,2) NOT NULL DEFAULT '0',
	hash TEXT,
	terminal TEXT,
	message TEXT,
	brief TEXT,
        "comment" TEXT
);
