
CREATE TABLE sk_invoices (
    id integer PRIMARY KEY,
    amount NUMERIC(16,2) NOT NULL default '0.00' CHECK (amount > 0),
    account integer not null default '1',
    "desc" TEXT,
    phone TEXT,
    resp_person integer NOT NULL DEFAULT '0' CHECK (resp_person >= 0),
    creation_time text NOT NULL default (datetime('now')),
    pay_time text NOT NULL default '1970-01-01 00:00',
    comment TEXT null,
    hash text not null default ''
);

CREATE TABLE sk_payments (
        payment_id integer PRIMARY KEY,
	account_id integer  default '0' NOT NULL CHECK (account_id > 0),
	operator_id integer  default '0' NOT NULL CHECK (operator_id >= 0),
	doc_id integer  default '0' NOT NULL CHECK (doc_id >= 0),
	status integer not null default '0' CHECK (status >= 0 AND status < 3),
	"date" text NOT NULL default (datetime('now')),
	sum numeric(16,2) NOT NULL DEFAULT '0',
	hash TEXT,
	terminal TEXT,
	message TEXT,
	brief TEXT,
        "comment" TEXT
);
