<?php

include_once ('PaymentGateway.php');

class Roboxchange extends PaymentGateway {
    var	$hash = '';

    public function __construct( $amount=0, $invoice='', $desc='', $currency='USD') {
	$this->selector = 'ROBOXCHANGE';
	parent::__construct($amount, $invoice, $currency, $desc);
    }

    protected function prepareSubmit() {
	$this->gatewayUrl = 'https://merchant.roboxchange.com/Index.aspx';
	$this->addField('MrchLogin', $this->config['login']);
    	if ( $this->amount > 0)
    	    $this->addField('OutSum', $this->amount);
    	if ( !empty( $this->invoice))
    	    $this->addField('InvId', $this->invoice);
    	if ( !empty( $this->desc))
    	    $this->addField('Desc', $this->desc);
	$this->addField('Encoding', 'utf-8');
	if ( isset($GLOBALS['LANG']))
	    $this->addField('Culture', $GLOBALS['LANG']);
	$this->addField('SignatureValue', strtoupper(md5("$this->config['login']:$this->amount:$this->invoice:$this->config['password1']")));
    }
    /**
     * Enables the test mode
     *
     * @param none
     * @return none
     */
    public function enableTestMode() {
        $this->testMode = TRUE;
    }

    private function CheckMD5() {
	$key = $this->amount .':'. $this->invoice .':'. $this->config['password2'];
	// we use strtoupper() because of the differences between PHP and ASP...
	return ($this->hash === strtoupper(md5($key)));
    }
    
    public function validateIpn() {
	if ((count($_POST) == 0) || (count($_POST)>50) || !isset($_POST['OutSum']) || !isset($_POST['InvId']) || !isset($_POST['SignatureValue']))
	    return false; // Silently exited. Too many params;
	$this->amount = @$_POST['OutSum'];
	$this->invoice = @$_POST['InvId'];
	foreach ($_POST as $field=>$value)
    	    if (substr($field, 0, 3) != 'SHP')
    	        $this->ipnData[$field] = $value;
	$this->hash = strtoupper(@$_POST['SignatureValue']);
	if ( $this->CheckMD5()) {
	// Invoice checking
	// if ( !$this->merchant->find_invoice( $this->invoice, $this->GetCurrency()) != $this->amount)
	//	return false;
	// Invoice paying
	//	if ( $this->merchant->pay_invoice( $this->invoice, $this->GetCurrency())) {
		echo('OK'.$this->invoice);
		return true;
//	    }
	}
	echo("Bad sign\n");
	return false;
    }
    
}


?>