<?php

include_once ('PaymentGateway.php');

define('WM_GET', 0);
define('WM_POST', 1);
define('WM_LINK', 2);

class Webmoney extends PaymentGateway {
	var	$mode = '';
	var	$sys_invs_no = '';
	var	$sys_trans_no = '';
	var	$sys_trans_date = '';
	var	$payer_purse = '';
	var	$payer_wm = '';
	var	$hash = '';
	var	$paymer_number = '';
	var	$paymer_email = '';
	var	$telepat_phonenumber = '';
	var	$telepat_orderid = '';
	var	$payment_creditdays = '';

    public function __construct( $amount=0, $invoice='', $desc='', $currency='USD') {
	$this->selector = 'WEBMONEY';
	parent::__construct($amount, $invoice, $currency, $desc);
    }

    protected function prepareSubmit() {
	$this->gatewayUrl = 'https://merchant.wmtransfer.com/lmi/payment.asp';
	if ( $this->amount > 0)
	    $this->addField('LMI_PAYMENT_AMOUNT', $this->amount);
	if ( !empty( $this->invoice))
	    $this->addField('LMI_PAYMENT_NO', $this->invoice);
	if ( !empty( $this->desc))
	    $this->addField('LMI_PAYMENT_DESC', $this->desc);
	$this->addField('LMI_PAYEE_PURSE', $this->config['purse']);
	$this->addField('LMI_RESULT_URL', $this->ipnUrl.'/wm_ipn.php');
	if ( !empty($this->config['success_url']))
	    $this->successUrl = $this->config['success_url'];
	$this->addField('LMI_SUCCESS_URL', $this->ipnUrl.$this->successUrl);
	$this->addField('LMI_SUCCESS_METHOD', WM_POST);
	if ( !empty($this->config['fail_url']))
	    $this->successUrl = $this->config['fail_url'];
	$this->addField('LMI_FAIL_URL', $this->ipnUrl.$this->failUrl);
	$this->addField('LMI_FAIL_METHOD', WM_POST);
    }
    /**
     * Enables the test mode
     *
     * @param none
     * @return none
     */
    public function enableTestMode() {
	$this->testMode = TRUE;
	$this->addField('LMI_SIM_MODE', '1');
    }

    private function say_no() {
	echo('NO');
	exit();
    }

    private function CheckMD5() {
	$key = $this->config['purse'] . $this->amount . $this->invoice;
	$key .= $this->mode . $this->sys_invs_no . $this->sys_trans_no;
	$key .= $this->sys_trans_date . $this->config['secret'] . $this->payer_purse;
	$key .= $this->payer_wm;
	// we use strtoupper() because of the differences between PHP and ASP...
	return ($this->hash === strtoupper(md5($key)));
    }
    
    public function validateIpn() {
	if ((count($_POST) == 0) || (count($_POST)>50) || !isset($_POST['LMI_PAYEE_PURSE']) || !isset($_POST['LMI_PAYMENT_AMOUNT']) || !isset($_POST['LMI_PAYMENT_NO']) || !isset($_POST['LMI_MODE']))
	    return false; // Silently exited. Too many params;
	if ( @$_POST['LMI_PAYEE_PURSE'] !== $this->config['purse'])
	    $this->say_no();
	$this->amount = @$_POST['LMI_PAYMENT_AMOUNT'];
	$this->invoice = @$_POST['LMI_PAYMENT_NO'];
	$this->mode = @$_POST['LMI_MODE'];
	$this->payer_wm = @$_POST['LMI_PAYER_WM'];
	$this->paymer_number = @$_POST['LMI_PAYMER_NUMBER'];
	$this->paymer_email = @$_POST['LMI_PAYMER_EMAIL'];
	$this->telepat_phonenumber = @$_POST['LMI_TELEPAT_PHONENUMBER'];
	$this->telepat_orderid = @$_POST['LMI_TELEPAT_ORDERID'];
	$this->payment_creditdays = @$_POST['LMI_PAYMENT_CREDITDAYS'];
	foreach ($_POST as $field=>$value)
	    if (substr($field, 0, 4) != 'LMI_')
	        $this->ipnData[$field] = $value;
	if (isset($_POST['LMI_PREREQUEST']) && ($_POST['LMI_PREREQUEST'] == 1)) {
	    // Prerequest
	    // Invoice checking
	    // if ( !$this->merchant->find_invoice( $this->invoice, $this->GetCurrency()) != $this->amount)
	    //	$this->say_no();
	    echo('YES');
	    exit();
	} elseif ( isset($_POST['LMI_HASH']) && isset($_POST['LMI_SYS_INVS_NO']) && isset($_POST['LMI_SYS_TRANS_NO']) && isset($_POST['LMI_SYS_TRANS_DATE']) && isset($_POST['LMI_PAYER_PURSE'])) {
	    $this->hash = @$_POST['LMI_HASH'];
	    $this->sys_invs_no = @$_POST['LMI_SYS_INVS_NO'];
	    $this->sys_trans_no = @$_POST['LMI_SYS_TRANS_NO'];
	    $this->sys_trans_date = @$_POST['LMI_SYS_TRANS_DATE'];
	    $this->payer_purse = @$_POST['LMI_PAYER_PURSE'];
	    if ( $this->CheckMD5()) {
	    // Invoice checking
	    // if ( !$this->merchant->find_invoice( $this->invoice, $this->GetCurrency()) != $this->amount)
	    //	return false;
	    // Invoice paying
	    // if ( $this->merchant->pay_invoice( $this->invoice, $this->GetCurrency()))
		return true;
	    }
	}
	return false;
    }

}


?>